MrMap/urls.py
from django.contrib import admin
from django.urls import path, include

from MrMap.settings import DEBUG

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('users.urls')),
    path('structure/', include('structure.urls')),
    path('resource/', include('service.urls')),
    path('monitoring/', include('monitoring.urls')),
    path('editor/', include('editor.urls')),
    path('captcha/', include('captcha.urls')),
    path("i18n/", include("django.conf.urls.i18n")),
    path('api/', include('api.urls')),
    path('csw/', include('csw.urls')),
    path('quality/', include('quality.urls')),
]

if DEBUG:
    import debug_toolbar
    urlpatterns.append(
        path('__debug__/', include(debug_toolbar.urls))
    )

handler404 = "structure.views.handler404"
handler500 = "structure.views.handler500"

api/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 15.08.19

"""

from django.urls import path, include


# Routers provide an easy way of automatically determining the URL conf.
from rest_framework import routers

from api.views import *

router = routers.DefaultRouter()
# catalogue api
router.register('catalogue', CatalogueViewSet, basename="catalogue")
router.register('suggestion', SuggestionViewSet, basename="suggestion")
router.register('category', CategoryViewSet, basename="category")
# modular parts of api
router.register('organization', OrganizationViewSet, basename="organization")
router.register('pending-task', PendingTaskViewSet, basename="pending-task")
router.register('metadata', MetadataViewSet, basename="metadata")
router.register('service', ServiceViewSet, basename="service")
router.register('layer', LayerViewSet, basename="layer")
router.register('group', GroupViewSet, basename="group")
router.register('monitoring', MonitoringViewSet, basename="monitoring")

app_name = "api"
urlpatterns = [
    path("", include(router.urls)),
    path("menu", menu_view, name="menu"),
    path("generate-token", generate_token, name="generate-token"),
]

csw/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 05.05.20

"""
from django.urls import path

from csw.views import *

app_name = 'csw'
urlpatterns = [
    path('', get_csw_results, name='get-csw-results'),
    path('harvest/<metadata_id>', harvest_catalogue, name='harvest-catalogue'),
]

service/urls.py
from django.urls import path

from editor.views import EditMetadata, RestoreMetadata, DatasetDelete
from editor.wizards import ACCESS_EDITOR_WIZARD_FORMS, AccessEditorWizard, EditDatasetWizard, DATASET_WIZARD_FORMS
from service.autocompletes import MetadataAutocomplete, MetadataServiceAutocomplete, MetadataLayerAutocomplete, \
    MetadataFeaturetypeAutocomplete
from service.views import *
from service.wizards import NewResourceWizard, NEW_RESOURCE_WIZARD_FORMS

app_name = 'resource'
urlpatterns = [
    # index views
    path('wms/', WmsIndexView.as_view(), name='wms-index'),
    path('wfs/', WfsIndexView.as_view(), name='wfs-index'),
    path('csw/', CswIndexView.as_view(), name='csw-index'),
    path('datasets/', DatasetIndexView.as_view(), name='datasets-index'),
    path('logs/', LogsIndexView.as_view(), name='logs-view'),

    # PendingTasks
    path('pending-tasks/', PendingTaskView.as_view(), name="pending-tasks"),

    # actions
    path('add', NewResourceWizard.as_view(form_list=NEW_RESOURCE_WIZARD_FORMS,), name='add'),
    path('<pk>/remove', ResourceDeleteView.as_view(), name='remove'),
    path('<pk>/remove-dataset', DatasetDelete.as_view(), name='remove-dataset-metadata'),
    path('<pk>/edit-metadata', EditMetadata.as_view(), name='edit'),
    path('<pk>/edit-dataset-metadata', EditDatasetWizard.as_view(form_list=DATASET_WIZARD_FORMS, ignore_uncomitted_forms=True), name="dataset-metadata-wizard-instance"),
    path('<pk>/restore', RestoreMetadata.as_view(), name='restore'),
    path('<pk>/activate', ResourceActivateDeactivateView.as_view(), name='activate'),
    path('<pk>/access-edit', AccessEditorWizard.as_view(form_list=ACCESS_EDITOR_WIZARD_FORMS), name='access-editor-wizard'),
    # todo: refactor as generic view
    path('metadata/<metadata_id>/subscribe', metadata_subscription_new, name='subscription-new'),

    # todo: refactoring this as a generic view
    path('new-update/<metadata_id>', new_pending_update_service, name='new-pending-update'),
    path('pending-update/<metadata_id>', pending_update_service, name='pending-update'),
    path('dismiss-pending-update/<metadata_id>', dismiss_pending_update_service, name='dismiss-pending-update'),
    path('run-update/<metadata_id>', run_update_service, name='run-update'),

    # serivce urls
    # todo: refactoring this as a generic view
    path('metadata/<metadata_id>', get_service_metadata, name='get-service-metadata'),
    path('metadata/dataset/<pk>', DatasetMetadataXmlView.as_view(), name='get-dataset-metadata'),
    path('metadata/<metadata_id>/operation', get_operation_result, name='metadata-proxy-operation'),
    path('metadata/<metadata_id>/legend/<int:style_id>', get_metadata_legend, name='metadata-proxy-legend'),

    # detail view
    # todo: implement detail view for csw
    path('<pk>', ResourceTreeView.as_view(), name='detail'),
    path('<pk>/table', ResourceDetailTableView.as_view(), name='detail-table'),
    path('<pk>/related-datasets', ResourceRelatedDatasetView.as_view(), name='detail-related-datasets'),

    # html metadata detail view
    # todo: refactoring as class based detailview. Maybe we could use the ResourceTreeView
    path('metadata/html/<pk>', MetadataHtml.as_view(), name='get-metadata-html'),
    path('preview/<metadata_id>', get_service_preview, name='get-service-metadata-preview'),

    # autocompletes
    path('autocompletes/metadatas', MetadataAutocomplete.as_view(), name='autocomplete_metadata'),
    path('autocompletes/service-metadatas', MetadataServiceAutocomplete.as_view(), name='autocomplete_metadata_service'),
    path('autocompletes/layer-metadatas', MetadataLayerAutocomplete.as_view(), name='autocomplete_metadata_layer'),
    path('autocompletes/featuretype-metadatas', MetadataFeaturetypeAutocomplete.as_view(), name='autocomplete_metadata_featuretype'),

]

users/urls.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 28.05.19

"""
from django.contrib.auth.views import LogoutView, PasswordResetConfirmView
from django.urls import path
from .views import *

urlpatterns = [

    # Dashboard
    path('', HomeView.as_view(), name="home"),

    path('accounts/login', MrMapLoginView.as_view(), name="login"),
    path('accounts/login', MrMapLoginView.as_view(), name="password_reset_done"),
    path('accounts/login', MrMapLoginView.as_view(), name="password_reset_complete"),
    path('accounts/logout', LogoutView.as_view(), name='logout'),
    path('accounts/password_reset', MrMapPasswordResetView.as_view(), name='password_reset'),
    path('accounts/reset/<uidb64>/<token>/',
         PasswordResetConfirmView.as_view(template_name='users/views/logged_out/password_reset_or_confirm.html'),
         name='password_reset_confirm'),
    path('accounts/signup', SignUpView.as_view(), name='signup'),
    path('accounts/activate/<pk>', ActivateUser.as_view(), name='activate-user'),

    # user specific views of his profile
    path('accounts/profile', ProfileView.as_view(), name="profile"),
    path('accounts/profile', ProfileView.as_view(), name="password_change_done"),
    path('accounts/profile/password-change', MrMapPasswordChangeView.as_view(), name="password_change"),
    path('accounts/profile/edit', EditProfileView.as_view(), name="edit_profile"),

    # user subscriptions
    path('accounts/profile/subscriptions', SubscriptionTableView.as_view(), name='manage_subscriptions'),
    path('accounts/profile/subscriptions/add', AddSubscriptionView.as_view(), name='add_subscription'),
    path('accounts/profile/subscriptions/<pk>/edit', UpdateSubscriptionView.as_view(), name='edit_subscription'),
    path('accounts/profile/subscriptions/<pk>/delete', DeleteSubscriptionView.as_view(), name='delete_subscription'),
]

service/forms.py
"""
Author: Michel Peltriaux
Organization: Spatial data infrastructure Rhineland-Palatinate, Germany
Contact: michel.peltriaux@vermkv.rlp.de
Created on: 15.04.19

"""
from django import forms
from django.core.exceptions import ObjectDoesNotExist, ImproperlyConfigured
from django.urls import reverse_lazy
from django.utils.html import format_html

from MrMap.forms import MrMapForm, MrMapConfirmForm, MrMapWizardForm
from MrMap.messages import SERVICE_UPDATE_WRONG_TYPE, SERVICE_ACTIVATED_TEMPLATE, SERVICE_DEACTIVATED_TEMPLATE
from MrMap.validators import validate_get_capablities_uri
from django.utils.translation import gettext_lazy as _
from django.contrib import messages

from service.helper import service_helper
from service.helper.enums import OGCServiceEnum
from service.models import Service, MrMapGroup
from service import tasks
from service.settings import NONE_UUID
from structure.models import Organization


class RegisterNewResourceWizardPage1(forms.Form):
    get_request_uri = forms.URLField(
        validators=[validate_get_capablities_uri],
        label=_("Resource URL"),
        help_text=_("In case of a OGC service you may provide the GetCapabilities url.")
    )


class RegisterNewResourceWizardPage2(forms.Form):
    ogc_request = forms.CharField(label=_('OGC Request'), widget=forms.TextInput(attrs={'readonly': '', }))
    ogc_service = forms.CharField(label=_('OGC Service'), widget=forms.TextInput(attrs={'readonly': '', }))
    ogc_version = forms.CharField(label=_('OGC Version'), widget=forms.TextInput(attrs={'readonly': '', }))
    uri = forms.CharField(label=_('URI'), widget=forms.TextInput(attrs={'readonly': '', }))
    registering_with_group = forms.ModelChoiceField(
        label=_("Registration with group"),
        help_text=_("Select a group for which this resource shall be registered."),
        widget=forms.Select(attrs={'onchange': 'isFormUpdateEventHandler(event);'}),
        queryset=MrMapGroup.objects.none(),
        to_field_name='id',
        initial=1,
    )
    registering_for_other_organization = forms.ModelChoiceField(
        label=_("Registration for other organization"),
        help_text=_("If you need to register for another organization, select the group which has the publisher rights and select the organization in here."),
        required=False,
        queryset=Organization.objects.none(),
        to_field_name='id',
        empty_label=_("No other")
    )

    service_needs_authentication = forms.BooleanField(
        label=_("Service needs authentication"),
        required=False,
        initial=False,
        widget=forms.CheckboxInput(attrs={'onchange': 'isFormUpdateEventHandler(event);'})
    )
    username = forms.CharField(label=_("Username"), required=False, disabled=True)
    password = forms.CharField(label=_("Password"), required=False, widget=forms.PasswordInput, disabled=True)
    authentication_type = forms.ChoiceField(
        label=_("Authentication type"),
        required=False,
        disabled=True,
        choices=(('http_digest', 'HTTP Digest'), ('http_basic', 'HTTP Basic'))
    )

    def __init__(self,  *args, **kwargs):
        self.request = kwargs.pop('request', None)
        if not self.request:
            raise ImproperlyConfigured("request is needed for this form to configure fields with dependencies.")

        super(RegisterNewResourceWizardPage2, self).__init__(*args, **kwargs)
        registering_with_group_key = self.prefix+"-registering_with_group" if self.prefix else "registering_with_group"
        selected_group = None

        if registering_with_group_key in self.request.POST:
            selected_group = MrMapGroup.objects.get(id=int(self.request.POST.get(registering_with_group_key)))

        service_needs_authentication_key = self.prefix+"-service_needs_authentication" if self.prefix else "service_needs_authentication"
        service_needs_authentication = None
        if service_needs_authentication_key in self.request.POST:
            service_needs_authentication = True if self.request.POST.get(service_needs_authentication_key) == 'on' else False
        elif kwargs.get("initial", {}).get("service_needs_authentication", False):
            service_needs_authentication = True

        # initial the fields if the values are transfered
        if self.request.user is not None:
            user_groups = self.request.user.get_groups.filter(is_public_group=False, is_permission_group=False)
            self.fields["registering_with_group"].queryset = user_groups.all()
            self.fields["registering_with_group"].initial = user_groups.first()
        if selected_group is not None:
            self.fields["registering_for_other_organization"].queryset = selected_group.publish_for_organizations.all()
        elif self.request.user is not None and user_groups.first() is not None:
            self.fields[
                "registering_for_other_organization"].queryset = user_groups.first().publish_for_organizations.all()
        if service_needs_authentication:
            self.fields["service_needs_authentication"].initial = "on"
            # self.fields["service_needs_authentication"].required = True
            self.fields["username"].disabled = False
            self.fields["username"].required = True
            self.fields["password"].disabled = False
            self.fields["password"].required = True
            self.fields["authentication_type"].disabled = False
            self.fields["authentication_type"].required = True


class UpdateServiceCheckForm(MrMapForm):
    url_dict = ''
    get_capabilities_uri = forms.URLField(
        validators=[validate_get_capablities_uri]
    )
    keep_custom_md = forms.BooleanField(
        label=_("Keep custom metadata"),
        initial=True,
        required=False
    )

    def __init__(self, *args, **kwargs):
        self.current_service = None if 'current_service' not in kwargs else kwargs.pop('current_service')
        self.requesting_user = None if 'requesting_user' not in kwargs else kwargs.pop('requesting_user')
        super(UpdateServiceCheckForm, self).__init__(*args, **kwargs)

    def clean(self):
        cleaned_data = super(UpdateServiceCheckForm, self).clean()

        if "get_capabilities_uri" in cleaned_data:
            uri = cleaned_data.get("get_capabilities_uri")
            self.url_dict = service_helper.split_service_uri(uri)
            new_service_type = self.url_dict.get("service")

            if self.current_service.service_type.name != new_service_type.value:
                self.add_error(None, SERVICE_UPDATE_WRONG_TYPE)

        has_update_candidate_for_service = None
        try:
            # Get service object from db
            has_update_candidate_for_service = Service.objects.get(is_update_candidate_for=self.current_service)
        except ObjectDoesNotExist:
            pass

        if has_update_candidate_for_service:
            user = has_update_candidate_for_service.created_by_user \
                if has_update_candidate_for_service.created_by_user is not None \
                else 'unknown'

            self.add_error(None,
                           _("There are still pending update requests from user '{}' for this service.").format(user))

            if self.requesting_user == user:
                self.add_error(None,
                               format_html("See your pending update request <a href={}>here.</a>",
                                           reverse_lazy('resource:pending-update',
                                                        args=(self.current_service.metadata.id,))))
                # ToDo: check if user is in group of created_by field of update_cadidate

        return cleaned_data


class UpdateOldToNewElementsForm(forms.Form):
    action_url = ''

    def __init__(self, *args, **kwargs):
        new_elements = None if 'new_elements' not in kwargs else kwargs.pop('new_elements')
        removed_elements = None if 'removed_elements' not in kwargs else kwargs.pop('removed_elements')
        choices = None if 'choices' not in kwargs else kwargs.pop('choices')
        current_service = None if 'current_service' not in kwargs else kwargs.pop('current_service')
        super(UpdateOldToNewElementsForm, self).__init__(*args, **kwargs)

        # Prepare remove elements as choices
        remove_elements_choices = [(NONE_UUID, _("---"))]
        for elem in removed_elements:
            remove_elements_choices.append((elem.metadata.id, elem.metadata.identifier))

        # Add new form fields dynamically
        for elem in new_elements:
            self.fields['new_elem_{}'.format(elem.metadata.identifier)] = forms.ChoiceField(
                label="{} ({})".format(elem.metadata.identifier, elem.metadata.title),
                choices=remove_elements_choices,
                help_text=_("Select the old layer name, if this new layer was just renamed.")
                if current_service.is_service_type(OGCServiceEnum.WMS)
                else _("Select the old featuretype name, if this new featuretype was just renamed.")
            )

        if choices is not None:
            for identifier, choice in choices.items():
                self.fields['new_elem_{}'.format(identifier)].initial = choice

service/templates/includes/wfs/featuretype_detail.html
{% extends 'sceletons/card.html' %}
{% load i18n %}

{% block card-header-title-left %}
<h4 class="mb-1 mr-3" style="display: inline;">
    {% autoescape off %}{{THEME.ICONS.FEATURETYPE}}{% endautoescape %}
    <strong>{{ service.metadata.title }}</strong>
</h4>
<span class="d-inline-block" tabindex="0" data-toggle="tooltip" title="{% trans 'Open in new tab' %}">
    <h6 style="display: inline;"><a href="{% url 'resource:detail' service_md.id %}">{{THEME.ICONS.EXTERNAL_LINK}}</a></h6>
</span>
{% endblock %}
{% block card-header-title-right %}

{% endblock %}

{% load i18n %}
{% block card-body %}
    <div class="row mb-2 ">
        <div class="col-sm mb-2 text-center">
            {% if 'can_edit_metadata' in user_permissions %}
                <div class="dropdown">
                  <button class="btn {{THEME.CARD.BTN_SECONDARY_COLOR}} dropdown-toggle" type="button" id="id_edit_service_{{service.id}}_dropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    {% autoescape off %}{{THEME.ICONS.EDIT}}{% endautoescape %} {% trans 'Edit featuretype' %}
                  </button>
                  <div class="dropdown-menu" aria-labelledby="id_edit_service_{{service.id}}_dropdown">
                    <a class="dropdown-item" href="{% url 'editor:edit' service.metadata.id %}?current-view={{current_view}}&current-view-arg={{service.metadata.id}}">{% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Metadata' %}</a>
                    <a class="dropdown-item" href="{% url 'editor:edit_access' service.metadata.id %}">{% autoescape off %}{{THEME.ICONS.ACCESS}}{% endautoescape %} {% trans 'Access' %}</a>
                  </div>
                </div>
            {% endif %}
            </div><!--</col>-->
            {% if dataset_metadatas %}
                <div class="col-sm mb-2 text-center">
                    <div class="dropdown">
                <button class="btn {{THEME.CARD.BTN_INFO_COLOR}} dropdown-toggle" type="button" id="id_dataset_metadata_dropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    {% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Dataset Metadata' %}
                </button>

                <div class="dropdown-menu" aria-labelledby="id_dataset_metadata_dropdown">
                    {% for dataset in dataset_metadatas %}
                    <a class="dropdown-item" target="_blank" href="{{ dataset.html_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.NEWSPAPER}}{% endautoescape %} {% trans 'HTML' %}</a>
                    <a class="dropdown-item" target="_blank" href="{{ dataset.service_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.CAPABILITIES}}{% endautoescape %} {% trans 'XML' %}</a>
                    <a class="dropdown-item" href="{% url 'resource:dataset-metadata-wizard-instance' dataset.id %}?current-view={{current_view}}&current-view-arg={{service.metadata.id}}">{% autoescape off %}{{THEME.ICONS.EDIT}}{% endautoescape %} {% trans 'Edit' %}</a>
                    {% endfor %}
                </div>

            </div>
                </div><!--</col>-->
            {% endif %}
            <div class="col-sm mb-2 text-center">
                <div class="dropdown">
                  <button class="btn {{THEME.CARD.BTN_INFO_COLOR}} dropdown-toggle" type="button" id="id_metadata_dropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    {% autoescape off %}{{THEME.ICONS.METADATA}}{% endautoescape %} {% trans 'Service Metadata' %}
                  </button>
                  <div class="dropdown-menu" aria-labelledby="id_metadata_dropdown">
                      <a class="dropdown-item" target="_blank" href="{{ service_md.html_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.NEWSPAPER}}{% endautoescape %} {% trans 'HTML' %}</a>
                      <a class="dropdown-item" target="_blank" href="{{ service_md.service_metadata_uri }}">{% autoescape off %}{{THEME.ICONS.CAPABILITIES}}{% endautoescape %} {% trans 'XML' %}</a>
                  </div>
                </div>
            </div>
            <div class="col-sm mb-2 text-center">
            {% if 'can_edit_metadata' in user_permissions %}
                <a class="btn {{THEME.CARD.BTN_WARNING_COLOR}}" href="{% url 'editor:restore' service.metadata.id %}?current-view={{current_view}}&current-view-arg={{service.metadata.id}}">{% autoescape off %}{{THEME.ICONS.UNDO}}{% endautoescape %} {% trans 'Restore metadata' %}</a>
            {% endif %}
            </div><!--</col>-->
        </div><!--</row>-->
        <div class="row mb-2 ">
        <div class="col">


        {% include 'includes/wfs/featuretype_detail_table.html' %}
        {% with service as featuretype %}
            {% with service.id as id_accordion  %}
                {% with id_accordion_combined='elements' %}
                    {% include 'includes/wfs/show_featuretype_elements_accordion.html' %}
                {% endwith %}
            {% endwith %}
        {% endwith %}

        </div><!--</col>-->
</div><!--</row>-->
{% endblock %}